import java.io.BufferedWriter;
import java.io.IOException;


public class SourceMeme 
{

	public static final int fixedNetMode = 1;
	public static final int nearestNeibourghNetMode = 2;
	public static final int randonNetMode = 3;
	protected int defusionType;	
	
	public static final int HADV = 1;
	public static final int AD = 2;
	protected double eneryIni;        
	protected int happeningTime;   
	protected int seedsNum;         
	protected double propagationRate;
	protected int propagationNum;
	protected double waningRate;
	protected int memeType;
	protected int id;
	
	SourceMeme(int id, double memeEnery, int memeHappeningTime, int memeSeedsNum,         
			double memePropagationRate, double memeWaningRate, int memetype, 
			int defusionType)
	{
		this.id = id;
		eneryIni = memeEnery;
		happeningTime = memeHappeningTime;
		seedsNum = memeSeedsNum;
		propagationRate = memePropagationRate;
		propagationNum = (int)(Sociaty.population * propagationRate);
		waningRate = memeWaningRate;
		this.memeType = memetype;
		this.defusionType = defusionType;
	}
	
	public void debugPrint()
	{
//		System.out.println("id,meme type,defusion mode,energy," +
//		"happen time,seeds,defusion rate,waining rate");		
		System.out.print(id);
		if(memeType == HADV)
		{
			System.out.print(",HAdv");
		}
		else if(memeType == AD)
		{
			System.out.print(",Ad");
		}
		
		if(defusionType == fixedNetMode)
		{
			System.out.print(",fixed");
		}
		else if(defusionType == randonNetMode)
		{
			System.out.print(",random");
		}
		else if(defusionType == nearestNeibourghNetMode)
		{
			System.out.print(",nearest");
		}
		System.out.println("," + eneryIni + "," + happeningTime + ","
				+ seedsNum + "," + propagationRate + "," + waningRate);
	}
	

	public void outputToFile(BufferedWriter out) 
	throws IOException
	{
//		System.out.println("id,meme type,defusion mode,energy," +
//		"happen time,seeds,defusion rate,waining rate");
		
		out.append(String.valueOf(id));
		if(memeType == HADV)
		{
			out.append(",HAdv");
		}
		else if(memeType == AD)
		{
			out.append(",Ad");
		}
		
		if(defusionType == fixedNetMode)
		{
			out.append(",fixed");
		}
		else if(defusionType == randonNetMode)
		{
			out.append(",random");
		}
		else if(defusionType == nearestNeibourghNetMode)
		{
			out.append(",nearest");
		}
		out.append("," + eneryIni + "," + happeningTime + ","
				+ seedsNum + "," + propagationRate + "," + waningRate + "\n");
	}
	
	public String getDiffusionType()
	{
		if(defusionType == fixedNetMode)
		{
			return "fixed";
		}
		else if(defusionType == randonNetMode)
		{
			return "random";
		}
		else if(defusionType == nearestNeibourghNetMode)
		{
			return "nearest";
		}
		else
		{
			return null;
		}
	}
	

}
