import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;


public class Summary2 {

	/**
	 * @param args
	 * @throws IOException 
	 */
	
	public static void main(String[] args) throws IOException 
	{
		FileWriter fstream = new FileWriter(Sociaty.result_path + "summary.txt");
		
		BufferedWriter out = new BufferedWriter(fstream);
        out.append("hAdvEnery,hAdvSeed,hAdvDiffRate,hAdvWaningRate,hAdvTopo," +
        		"adEnery,adSeed,adDiffRate,adWaningRate,adTopo," +
        		"react average,react trend accumulate," + 
        		"react trend,start time,end time," + 
        		"action average,action trend accumulate," + 
				"action trend,start time,end time\n"); 
        
		String[] hAdvEnery = {"0.5-","0.8-"};
    	String[] hAdvSeed = {"5-","10-"};
    	String[] hAdvDiffRate = {"0.04-","0.07-"};
    	String[] hAdvWaningRate = {"0.95-","0.97-"};
    	String[] hAdvTopo = {"random-", "fixed-", "nearest-"};
    	String[] adEnery = {"0.4-","0.7-"};
    	String[] adSeed = {"10-","15-"};
    	String[] adDiffRate = {"0.05-","0.08-"};
    	String[] adWaningRate = {"0.95-","0.97-"};
    	String[] adTopo = {"random.txt", "fixed.txt", "nearest.txt"};
    	

		String[] hAdvEneryS = {"0.5","0.8"};
    	String[] hAdvSeedS = {"5","10"};
    	String[] hAdvDiffRateS = {"0.04","0.07"};
    	String[] hAdvWaningRateS = {"0.95","0.97"};
    	String[] hAdvTopoS = {"random", "fixed", "nearest"};
    	String[] adEneryS = {"0.4","0.7"};
    	String[] adSeedS = {"10","15"};
    	String[] adDiffRateS = {"0.05","0.08"};
    	String[] adWaningRateS = {"0.95","0.97"};
    	String[] adTopoS = {"random", "fixed", "nearest"};
    	
    	double[] react = new double[Sociaty.iteration];
    	double[] action = new double[Sociaty.iteration];
    	for(int i1 = 0; i1 < 2; i1++)
    	{
        	for(int i2 = 0; i2 < 2; i2++)
        	{
            	for(int i3 = 0; i3 < 2; i3++)
            	{
                	for(int i4 = 0; i4 < 2; i4++)
                	{
                    	for(int i5 = 0; i5 < 3; i5++)
                    	{
                        	for(int i6 = 0; i6 < 2; i6++)
                        	{
                            	for(int i7 = 0; i7 < 2; i7++)
                            	{
                                	for(int i8 = 0; i8 < 2; i8++)
                                	{
                                    	for(int i9 = 0; i9 < 2; i9++)
                                    	{
                                        	for(int i10 = 0; i10 < 3; i10++)
                                        	{
                                        		String fileName = 
                                        			Sociaty.result_path + 
                                        			hAdvEnery[i1] + 
                                        			hAdvSeed[i2] +
                                        			hAdvDiffRate[i3] +
                                            		hAdvWaningRate[i4] +
                                        			hAdvTopo[i5] +
                                        			adEnery[i6] +
                                        			adSeed[i7] +                                        			
                                            		adDiffRate[i8] +
                                            		adWaningRate[i9] + 
                                            		adTopo[i10];
                                        		String s = hAdvEneryS[i1] + "," +
                                        			hAdvSeedS[i2] + "," +
                                        			hAdvDiffRateS[i3] + "," +
                                            		hAdvWaningRateS[i4] + "," +
                                        			hAdvTopoS[i5] + "," +
                                        			adEneryS[i6] + "," +
                                        			adSeedS[i7] + "," +                                  			
                                            		adDiffRateS[i8] + "," +
                                            		adWaningRateS[i9] +  "," +
                                            		adTopoS[i10] + ",";
                                        		recordOneFile(fileName, 
                                        				react, action, out, s);
                                        	}	
                                    	}	
                                	}	
                            	}	
                        	}
                    	}
                	}
            	}
        	}
    	}
    	out.close();
	}
	
	static private void recordOneFile(String fileName, 
			double[] react, double[] action, BufferedWriter out, String s) 
	throws IOException
	{		
		FileInputStream in = null;
		try
		{
			if((in = new FileInputStream(fileName)) != null)
			{
				out.append(s);
				BufferedReader br = 
					new BufferedReader(new InputStreamReader(in));
			    for(int i = 0; i < 5; i++)
			    {
			    	br.readLine();
			    }
			    String strLine = null;
			    for(int i = 0; i < Sociaty.iteration; i++)
			    {
			    	strLine = br.readLine();
			    	if(strLine == null)
			    	{
			    		throw new IOException();
			    	}
			    	String[] ss = strLine.split(",");
	
			    	react[i] = Double.parseDouble(ss[32]);
			    	action[i] = Double.parseDouble(ss[33]);
			    }         
			    analyseOneFile(react, out);
			    analyseOneFile(action, out);
			}				
		    out.append("\n"); 
		    in.close();
		}
		catch(FileNotFoundException e)
		{
//			System.out.println("no file " + fileName);
		}
		catch(Exception e)
		{
			System.out.println("exception for " + fileName);
		}

	}
	
	static private void analyseOneFile(double[] data, BufferedWriter out) 
	throws IOException
	{
		analyseOneFile(0, Sociaty.iteration - 1, data, out); 
	}

	static private void analyseOneFile(int startTime, int endTime,
			double[] data, BufferedWriter out) 
	throws IOException
	{
		double ave = 0;
		for(int i = 0; i < data.length; i++)
		{
			ave += data[i];
		}
		ave /= data.length;
		
		double change = 0;
		while(Math.abs(change) < 1E-8 && endTime > 0)
		{
			change = data[endTime] - data[endTime - 1];
			endTime--;
		}
		endTime++;
		
		change = 0;
		while(Math.abs(change) < 1E-8 && startTime < endTime)
		{
			change = data[startTime + 1] - data[startTime];
			startTime++;
		}
		startTime--;
		
		double aveTrend = 0;
		for(int i = startTime; i <= endTime; i++)
		{
			aveTrend +=  data[i];
		}

		out.append(String.valueOf(ave) + ",");
		double d = aveTrend - ave * (endTime - startTime + 1);
		out.append(String.valueOf(d) + ",");
		
		aveTrend /= endTime - startTime + 1;
		if(aveTrend > data[Sociaty.iteration - 1])
		{
			out.append("better,");
		}
		else if(aveTrend < data[Sociaty.iteration - 1])
		{
			out.append("worser,");
		}
		else//averaveTrend = react[Sociaty.iteration - 1]
		{
			out.append("no trend,");
		}				
		out.append(String.valueOf(startTime) + ",");
		out.append(String.valueOf(endTime) + ",");
	}
}
